Multivariate Pattern Analysis in Python

# mvpa2.datasets.cosmo.ChainMapper

class `mvpa2.datasets.cosmo.``ChainMapper`(nodes, **kwargs)

  Class that amends ChainNode with a mapper-like interface.

  ChainMapper supports sequential training of a mapper chain, as well as reverse-mapping and mapping of single samples.

  Notes

  Available conditional attributes:

  - `calling_time+`: None
  - `raw_results`: None
  - `trained_dataset`: None
  - `trained_nsamples+`: None
  - `trained_targets+`: None
  - `training_time+`: None

  (Conditional attributes enabled by default suffixed with `+`)

  Attributes

  `descr` | Description of the object if any
  `nodes` |
  `pass_attr` | Which attributes of the dataset or self.ca to pass into result dataset upon call
  `postproc` | Node to perform post-processing of results
  `space` | Processing space name of this node

  Methods

  Parameters:

  nodes: list

  > Node instances.

  enable_ca : None or list of str

  > Names of the conditional attributes which should be enabled in addition to the default ones

  disable_ca : None or list of str

  > Names of the conditional attributes which should be disabled

  space : str, optional

  > Name of the ‘processing space’. The actual meaning of this argument heavily depends on the sub-class implementation. In general, this is a trigger that tells the node to compute and store information about the input data that is “interesting” in the context of the corresponding processing in the output dataset.

  pass_attr : str, list of str|tuple, optional

  > Additional attributes to pass on to an output dataset. Attributes can be taken from all three attribute collections of an input dataset (sa, fa, a – see `Dataset.get_attr()`), or from the collection of conditional attributes (ca) of a node instance. Corresponding collection name prefixes should be used to identify attributes, e.g. ‘ca.null_prob’ for the conditional attribute ‘null_prob’, or ‘fa.stats’ for the feature attribute stats. In addition to a plain attribute identifier it is possible to use a tuple to trigger more complex operations. The first tuple element is the attribute identifier, as described before. The second element is the name of the target attribute collection (sa, fa, or a). The third element is the axis number of a multidimensional array that shall be swapped with the current first axis. The fourth element is a new name that shall be used for an attribute in the output dataset. Example: (‘ca.null_prob’, ‘fa’, 1, ‘pvalues’) will take the conditional attribute ‘null_prob’ and store it as a feature attribute ‘pvalues’, while swapping the first and second axes. Simplified instructions can be given by leaving out consecutive tuple elements starting from the end.

  postproc : Node instance, optional

  > Node to perform post-processing of results. This node is applied in `__call__()` to perform a final processing step on the to be result dataset. If None, nothing is done.

  descr : str

  > Description of the instance

  Attributes

  `descr` | Description of the object if any
  `nodes` |
  `pass_attr` | Which attributes of the dataset or self.ca to pass into result dataset upon call
  `postproc` | Node to perform post-processing of results
  `space` | Processing space name of this node

  Methods

  `forward`(ds)
  `forward1`(data)

    Forward data or datasets through the chain.

    See `Mapper` for more information.

  `reverse`(data)

    Reverse-maps data or datasets through the chain (backwards).

    See `Mapper` for more information.

  `reverse1`(data)

    Reverse-maps data or datasets through the chain (backwards).

    See `Mapper` for more information.

  `train`(dataset)

    Train the mapper chain sequentially.

    The training dataset is used to train the first mapper. Afterwards it is forward-mapped by this (now trained) mapper and the transformed dataset and then used to train the next mapper. This procedure is done till all mappers are trained.

    Parameters: | dataset: `Dataset`

  `untrain`()

    Untrain all embedded mappers.